/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// DestinationsGoogleBigQueryApiService DestinationsGoogleBigQueryApi service
type DestinationsGoogleBigQueryApiService service

type ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest struct {
	ctx        context.Context
	ApiService *DestinationsGoogleBigQueryApiService
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest) Execute() ([]ActionAuthorizationResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationExecute(r)
}

/*
AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorization List of authorization objects

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest
*/
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorization(ctx context.Context) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest {
	return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []ActionAuthorizationResponseInner
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationExecute(r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorizationRequest) ([]ActionAuthorizationResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []ActionAuthorizationResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsGoogleBigQueryApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionAuthorization")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/google_big_query/actions/authorization"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest struct {
	ctx                                                                       context.Context
	ApiService                                                                *DestinationsGoogleBigQueryApiService
	appDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest(appDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	r.appDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest = &appDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
	return r
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) Execute() ([]AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetExecute(r)
}

/*
AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDataset List of datasets

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
*/
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDataset(ctx context.Context) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetExecute(r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) ([]AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsGoogleBigQueryApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDataset")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/google_big_query/actions/dataset"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest struct {
	ctx                                                                       context.Context
	ApiService                                                                *DestinationsGoogleBigQueryApiService
	appDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest(appDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	r.appDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest = &appDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
	return r
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) Execute() ([]AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectExecute(r)
}

/*
AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject List of projects

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
*/
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject(ctx context.Context) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest {
	return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectExecute(r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest) ([]AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsGoogleBigQueryApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/google_big_query/actions/project"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appDestinationGoogleBigQueryGoogleBigQueryDestinationActionProjectRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest struct {
	ctx                                                              context.Context
	ApiService                                                       *DestinationsGoogleBigQueryApiService
	appDestinationOneDriveOneDriveDestinationActionWriteModesRequest *AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest) AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest(appDestinationOneDriveOneDriveDestinationActionWriteModesRequest AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest {
	r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest = &appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	return r
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesExecute(r)
}

/*
AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModes List of write modes

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest
*/
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModes(ctx context.Context) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest {
	return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesExecute(r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModesRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsGoogleBigQueryApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionWriteModes")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/google_big_query/actions/writeModes"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest struct {
	ctx                          context.Context
	ApiService                   *DestinationsGoogleBigQueryApiService
	googleBigQueryStorageRequest *GoogleBigQueryStorageRequest
}

//
func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest) GoogleBigQueryStorageRequest(googleBigQueryStorageRequest GoogleBigQueryStorageRequest) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest {
	r.googleBigQueryStorageRequest = &googleBigQueryStorageRequest
	return r
}

func (r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest) Execute() (*GoogleBigQueryDestination, *http.Response, error) {
	return r.ApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateExecute(r)
}

/*
AppDestinationGoogleBigQueryGoogleBigQueryDestinationCreate Create destination

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest
*/
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationCreate(ctx context.Context) ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest {
	return ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return GoogleBigQueryDestination
func (a *DestinationsGoogleBigQueryApiService) AppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateExecute(r ApiAppDestinationGoogleBigQueryGoogleBigQueryDestinationCreateRequest) (*GoogleBigQueryDestination, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *GoogleBigQueryDestination
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsGoogleBigQueryApiService.AppDestinationGoogleBigQueryGoogleBigQueryDestinationCreate")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/google_big_query"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.googleBigQueryStorageRequest == nil {
		return localVarReturnValue, nil, reportError("googleBigQueryStorageRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.googleBigQueryStorageRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
